%Dino Sejdinovic, 2013
%D. Sejdinovic, A. Gretton and W. Bergsma.  A KERNEL TEST FOR THREE-VARIABLE INTERACTIONS, 2013.

%dataset A for 3-variable interaction testing
%the product X1*Y1 determines the sign of Z1
%and the remaining n−1 dimensions are independent (noise)
%pairwise independent but mutually dependent

function [xx,yy,zz] = generate_dataA(n,dx)
%--  n   --- number of samples
%--  dx  --- dimensionality
    xx=randn(n,dx);
    yy=randn(n,dx);
    zz=randn(n,dx);
    zz(:,1)=sign(xx(:,1).*yy(:,1)).*exprnd(1/sqrt(2),n,1);
end
