%Dino Sejdinovic, 2013
%D. Sejdinovic, A. Gretton and W. Bergsma.  A KERNEL TEST FOR THREE-VARIABLE INTERACTIONS, 2013.


%dataset B for 3-variable interaction testing
%dependence of Z on pair (X,Y) is stronger than on X and Y individually
%first dimension if z is a noisy version of:
%                       (x1)^2 w.p. 1/3
%                       (y1)^2 w.p. 1/3
%                        x1*y1 w.p. 1/3

function [xx,yy,zz] = generate_dataB(n,dx)
%--  n   --- number of samples
%--  dx  --- dimensionality
    xx=randn(n,dx);
    yy=randn(n,dx);
    zz=randn(n,dx);
    for jj=1:n
    u=rand;
    if u<1/3
    zz(jj,1)=xx(jj,1)^2+0.1*randn;
    elseif u<2/3
    zz(jj,1)=yy(jj,1)^2+0.1*randn;
    else
    zz(jj,1)=xx(jj,1)*yy(jj,1)+0.1*randn;
    end
    end
end

